/**
 * Created by Sam R.
 * on 17-12-2011
 * at 09:39
 */
package com.cirrial.ld22 {
import org.flixel.FlxG;
import org.flixel.FlxGame;
import org.flixel.FlxGroup;
import org.flixel.FlxObject;
import org.flixel.FlxSound;

[SWF(width = "640", height = "480", backgroundColor = "#000000")]
[Frame(factoryClass="com.cirrial.ld22.Preloader")]
public class Main extends FlxGame {

    public static const SCREEN_WIDTH:uint = 640;
    public static const SCREEN_HEIGHT:uint = 480;
    public static const ZOOM_LEVEL:uint = 2;

    public static const TILE_SIZE:uint = 20;
    public static const EXPECTED_TIMESTEP:Number = 1/60;
    public static const GRAVITY:uint = 900;
    public static const TRANSFER_RATE:Number = 10; // energies per second
    public static const DRAIN_RATE:Number = 0.4;

    // Keybindings and their defaults!
    public static var KEY_LEFT:String = "LEFT";
    public static var KEY_RIGHT:String = "RIGHT";
    public static var KEY_UP:String = "UP";
    public static var KEY_DOWN:String = "DOWN";
    public static var KEY_JUMP:String = "X";
    public static var KEY_ACTION:String = "C";

    public static var terminalsSeen:Array; // what text has been seen

    public function Main() {
        terminalsSeen = new Array();
        var i:int;
        for(i = 0; i<TerminalStrings.TERMINAL_STRINGS.length; i++) {
            terminalsSeen[i] = false;
        }

        super(SCREEN_WIDTH/ZOOM_LEVEL, SCREEN_HEIGHT/ZOOM_LEVEL, MenuState, ZOOM_LEVEL, 60, 60);
    }

    public static function getClosestObject(source:FlxObject, group:FlxGroup, maxDistance:Number):FlxObject {
        var best:FlxObject = null;
        var bestSqDist:Number = maxDistance * maxDistance;

        for each(var obj:FlxObject in group.members) {
            if(obj.alive) {
                var dx:Number = obj.x - source.x;
                var dy:Number = obj.y - source.y;
                var sqDist:Number = dx*dx + dy*dy;
                if(sqDist < bestSqDist) {
                    bestSqDist = sqDist;
                    best = obj;
                }
            }
        }
        return best;
    }

    public static function playSound(sound:Class, source:FlxObject):void {
        var flxSnd:FlxSound = new FlxSound();
        flxSnd.loadEmbedded(sound);
        flxSnd.proximity(source.x, source.y, FlxG.camera.target, 50);
        flxSnd.play();
    }

    public static function getLogsRead():uint {
        var count:uint = 0;
        for(var i:int = 0; i<TerminalStrings.TERMINAL_STRINGS.length; ++i) {
            if(terminalsSeen[i]) {
                ++count;
            }
        }
        return count;
    }
}
}
